﻿/*
 * Created by SharpDevelop.
 * User: Hauptnutzer
 * Date: 04.10.2010
 * Time: 09:35
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;
using System.Threading.Tasks;


namespace AKFB_2._
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
		
		public int EHV_SortKonstante = 4;
		private int Min_Kantenkontrast = 5;
		private double[,] Blurdiag;
		private string[] Dateinamen;
		private bool Abbruch_Auswertung;
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			Abbruch_Auswertung = false;
			Dateinamen = new string[10000];

		}
		
		void DateiBrowserClick(object sender, EventArgs e)
		{
			
			// Dateibrowser-Dialog aufrufen
			OpenFileDialog openFileDialog1 = new OpenFileDialog();
			openFileDialog1.Multiselect = true;
			openFileDialog1.Filter = "JPG files (*.jpg)|*.jpg|All files (*.*)|*.*";
			// TODO: Verzeichnis aus Ini-Datei einlesen
			openFileDialog1.InitialDirectory = System.IO.Path.GetDirectoryName(Application.ExecutablePath);
			openFileDialog1.RestoreDirectory = true;

			// Alle ausgewählten Dateien in string-Liste speichern
			int i;
			
			if(openFileDialog1.ShowDialog() == DialogResult.OK)
			{
				i = 0;
				foreach (String file in openFileDialog1.FileNames)
				{
					// Create a PictureBox.
					Dateinamen [i] = file;
					i++;
				}
			}
			
		}
		
		void AbbruchClick(object sender, EventArgs e)
		{
			Abbruch_Auswertung = true;
		}
		
		void StarteBildAnalyseClick(object sender, EventArgs e)
		{
			Abbruch.Enabled = true;
			Abbruch_Auswertung = false;
			
			DateTime StartZeit = DateTime.Now;
			int i = 0;
			int NumberOfFrames = 0;
			
			if ((i == 0) && (Dateinamen[i] == null))
			{
				berechneAKFB(filenameBox.Text);
				NumberOfFrames = 1;
				DateTime Endzeit = DateTime.Now;
				TimeSpan Zeitdauer = Endzeit - StartZeit;
				
				//Zeitdauer.TotalMilliseconds / 1000;
				label_fps_Wert.Text = "Geschwindigkeit: " +  ( (double)NumberOfFrames / (Zeitdauer.TotalMilliseconds / 1000)).ToString() + " fps";
				
			}
			else
			{
				while (Dateinamen[i] != null)
				{
					filenameBox.Text = Dateinamen[i];
					try{
						this.Invalidate();
						Application.DoEvents();
					}
					catch{
						
					}
					
					NumberOfFrames++;
					
					berechneAKFB(Dateinamen[i]);
					System.GC.Collect();
					Dateinamen[i] = null;
					i++;
					if (i > Dateinamen.Length -1)
						break;
					
					// Abbruch bei Drücken des Buttons;
					// Wenn Abbruchbutton gedrückt, Abbrechen
					{
						if (Abbruch_Auswertung == true)
						{
							tConsole.Text = "Auswertung durch Nutzer abgebrochen";
							// Liste der Dateinamen leeren
							for (int j = 0; j < Dateinamen.Length; j++)
								Dateinamen[j] = null;
							
							return;
						}
						
					}
					
					
					
					
					
					
					
				}
				DateTime Endzeit = DateTime.Now;
				TimeSpan Zeitdauer = Endzeit - StartZeit;
				
				//Zeitdauer.TotalMilliseconds / 1000;
				label_fps_Wert.Text = "Geschwindigkeit: " +  ( (double)NumberOfFrames / (Zeitdauer.TotalMilliseconds / 1000)).ToString() + " fps";
				filenameBox.Text = "";
			}
			tConsole.Text = "Auftrag erledigt";
			
			GC.Collect();
			
		}
		
		void TrackBar_AzimutScroll(object sender, EventArgs e)
		{
			zeichneMesh( ref Blurdiag, false);
		}
		
		void TrackBar1Scroll(object sender, EventArgs e)
		{
			zeichneMesh( ref Blurdiag, false);
		}
		
		void berechneAKFB(string myDateiname)
		{
			int testlinienlaenge;
			testlinienlaenge = 10;
			int uniformitaetsbereich;
			uniformitaetsbereich = 3;
			double uniformitaetsguete;
			uniformitaetsguete = 0.2;
			int auswertegebiete = 12;
			
			// Multi-Threading ein-/aus
			bool ForceSingleThreading;
			if (checkBox_forceSingleCoreCalculation.Checked == true)
				ForceSingleThreading = true;
			else
				ForceSingleThreading = false;
				
			
			
			//Image testbild;
			byte[] imagestream;
			int[] matrixsize;
			matrixsize = new int[2];
			//int[] NZeros;
			//NZeros = new int[4];
			
			int[,] Bild;
			int[,] dver, dhor, betragskarte;
			int[,,] EVektor;
			

			double[,] Abklinggraph;
			
			
			
			// Variablen für Testzwecke
			double[] temp_double_array;
			temp_double_array = new double[2];
			//double[,] zielarray;
			double[,] printarray;
			printarray = new double[10,10];
			
			Image testbild;
			//Image Kontrollausschnitt;
			
			try
			{
				tConsole.Text = "Lade Bilddatei....";
				testbild = Image.FromFile(myDateiname);
			}
			catch
			{
				tConsole.Text = "Datei konnte nicht geladen werden.";
				return;
			}
			

			

			// Kontrollbildausschnitt anzeigen
			{
				// Crop berechnen
				
				if ( (testbild.Width > mypictureBox.Width ) || (testbild.Height > mypictureBox.Height) )
				{ // Wenn Bild groeßer als Crop-Bereich, Crop machen
					try{
						Bitmap TestBMP;
						TestBMP = (Bitmap) testbild;
						Rectangle rect = new Rectangle(Convert.ToInt16(testbild.Width/2),Convert.ToInt16(testbild.Height/2), mypictureBox.Width, mypictureBox.Height);
						Bitmap cropped = TestBMP.Clone(rect, testbild.PixelFormat);
						mypictureBox.Image = (Image) cropped;}
					catch{
						mypictureBox.Image = testbild;
					}
					refreshForm();
					
				}
				else
				{ // Wenn Bild kleiner als Crop-Bereich -> einfach anzeigen
					mypictureBox.Image = testbild;
					//mypictureBox.
					refreshForm();
				}
				
				
				
				
				

			}
			
			
			{// Modulablauf
				imagestream = BildToByteArray(ref testbild, System.Drawing.Imaging.ImageFormat.Bmp);
				Bild = IntArrayausByteStream(imagestream, testbild.Height, testbild.Width, ForceSingleThreading);

				matrixsize = getmatrixsize(ref Bild);
				dver = diff_ver(Bild, ForceSingleThreading);
				dhor = diff_hor(Bild, ForceSingleThreading);

				betragskarte = ErzeugeBetragskarte(dver, dhor, ForceSingleThreading);
				tConsole.Text = "Betragskarte erzeugt";
				refreshForm();
				
				// Wenn Abbruchbutton gedrückt, Abbrechen
				if (Abbruch_Auswertung == true)
					return;
				
				EVektor = ErzeugeEVektor( dver, dhor, betragskarte, ForceSingleThreading);
				tConsole.Text = "EVektoren erzeugt";
				refreshForm();
				// Wenn Abbruchbutton gedrückt, Abbrechen
				if (Abbruch_Auswertung == true)
					return;

				
				EVektor = EHV_Sort1(EVektor, betragskarte, EHV_SortKonstante , Min_Kantenkontrast, ForceSingleThreading);
				tConsole.Text = "EHVSort1 angewandt";
				refreshForm();
				// Wenn Abbruchbutton gedrückt, Abbrechen
				if (Abbruch_Auswertung == true)
					return;
				
				//NZeros[0] = CountNZero(ref EVektor, 2);
				EVektor = EHV_Sort2(EVektor, EHV_SortKonstante, uniformitaetsbereich, uniformitaetsguete, ForceSingleThreading);
				tConsole.Text = "EHVSort2 angewandt";
				refreshForm();
				// Wenn Abbruchbutton gedrückt, Abbrechen
				if (Abbruch_Auswertung == true)
					return;
				
				//NZeros[1] = CountNZero(ref EVektor, 2);
				Abklinggraph = ErzeugeAbklinggraph(EVektor, Bild, testlinienlaenge, ForceSingleThreading);
				tConsole.Text = "Abklinggraph erzeugt";
				refreshForm();
				// Wenn Abbruchbutton gedrückt, Abbrechen
				if (Abbruch_Auswertung == true)
					return;
				
				
				//NZeros[2] = CountNZero(ref EVektor, 2);
				Blurdiag = ErzeugeBlurdiag(Abklinggraph, auswertegebiete, ForceSingleThreading);
			}
			

			label_Meshbox.Text = "2D-Unschärfe-Graph:" + myDateiname;
			// Wenn Abbruchbutton gedrückt, Abbrechen
			if (Abbruch_Auswertung == true)
				return;
			zeichneMesh(ref Blurdiag, true);
			refreshForm();
		}
		
		private void refreshForm ()
		{
			this.Invalidate();
			Application.DoEvents();
			
		}
		
//		private double[] ErzeugeRadialerUnschaerfegraph (ref double[,] Blurgraph)
//		{
//			int i,j,k;
//			int anzahl;
//			double summe;
//			int Vektorlaenge;
//			int[] matrixsize;
//
//			matrixsize = new int[2];
//
//			matrixsize = getmatrixsize(ref Blurgraph);
//			Vektorlaenge = Convert.ToInt16(Math.Round(Math.Sqrt( Math.Pow( ((double)matrixsize[0]+1)-0.1,2) + Math.Pow( ((double) matrixsize[1] +1 -0.1) ,2) )/2 ) );
//
//			double[] RadialBlurgraph;
//			RadialBlurgraph = new double[Vektorlaenge];
//
//			for ( k = 0 ; k < RadialBlurgraph.Length; k++)
//			{
//				anzahl = 0;
//				summe = 0;
//				for (i = 0; i <= matrixsize[0]; i++)
//				{
//					for (j = 0 ; j <= matrixsize[1]; j++)
//					{
//						if (Math.Round ( Math.Sqrt(Math.Pow(i - ((double)matrixsize[0]) / 2 ,2) + Math.Pow(j - ((double)matrixsize[1]) / 2 ,2) ) ) == k)
//						{
//							//Blurgraph[i,j] = k;
//							anzahl++;
//							summe = summe + Blurgraph[i,j];
//						}
//					}
//				}
//
//				RadialBlurgraph[k] = summe / anzahl;
//			}
//
//			return RadialBlurgraph;
//		}
		
		private void zeichneMesh (ref double[,] Matrix, bool saveImage)
		{
			mesh MeshPlotter = new mesh(myMeshBox.Width-1, myMeshBox.Height -1);
			Bitmap MeshPlot;
			{ // Mesh-Parameter einfügen
				MeshPlotter.tauscheXY_von_Matrix = true;
				MeshPlotter.spiegleX_von_Matrix = true;
				MeshPlotter.ZMAX = 13;
				MeshPlotter.ZMIN = 0 ;
				MeshPlotter.zeichneFlächen = true;
				MeshPlotter.pTransparenz = 0.65;
				
				// Kippung und Azimut reinschreiben
				try{
					MeshPlotter.az = trackBar_Azimut.Value;
					label_Azimut.Text = "Azimut: " + Convert.ToString(trackBar_Azimut.Value) + " °";
				}
				catch{
					MeshPlotter.az = 35;
				}
				
				try{
					MeshPlotter.el = trackBar_Kippung.Value;
					label_Kippung.Text = "Kippung: " + Convert.ToString(trackBar_Kippung.Value) + " °";
				}
				catch{
					MeshPlotter.el = 45;
				}
			}
			MeshPlot = MeshPlotter.createmesh(Blurdiag);
			
			//mypictureBox.Image = Graph;
			myMeshBox.Image = MeshPlot;
			
			
			if (saveImage)
			{
				MeshPlot.Save(filenameBox.Text + ".png",ImageFormat.Png);
			}
		}
		
		private int[,] IntArrayausByteStream (byte[] stream, int xsize, int ysize, bool DoItSequential)
		{
			
			//int i,j;
			int[,] Bild;
			
			
			//zaehler = 54;
			Bild = new int[xsize,ysize];
			if (true == DoItSequential)
			{
				int i,j;
				// ALTER SEQUENTIELLER CODE:
				for ( i = 0 ; i <= xsize-1; i++)
				{
					for (j = 0 ; j <= ysize-1; j++)
					{
						Bild[xsize-1 - i,j] = (stream[54 + 3 * j  + i *  3 * ysize] + stream[54 + 3 * j  + i *  3 * ysize +1] + stream[54 + 3 * j   + i *  3 * ysize +2]) / 3;
					}
				}
				return Bild;
			}
			else
			{
				// NEUER PARALLELISIERTER CODE:
				Action<int> forLoop = i => //Anfang der Parallel.For Schleife
				{
					for (int j = 0 ; j <= ysize-1; j++)
					{
						Bild[xsize-1 - i,j] = (stream[54 + 3 * j  + i *  3 * ysize] + stream[54 + 3 * j  + i *  3 * ysize +1] + stream[54 + 3 * j   + i *  3 * ysize +2]) / 3;
					}
				};
				Parallel.For(0, xsize, forLoop);
				
				return Bild;
			}
		}
		
		private double[,] ErzeugeBlurdiag (double[,] Abklinggraph, int Auswertegebiete, bool DoItSequential)
		{
			if (true == DoItSequential)
			{
				// Sequentieller Code
				int Auswertegebiete_ver;
				int anzahl;
				int i, j, k, L;
				int comp, comp_ver;
				int[] matrixsize;

				matrixsize = new int[2];
				matrixsize = getmatrixsize(ref Abklinggraph);
				matrixsize[0] = matrixsize[0] + 2;

				matrixsize[1] = matrixsize[1] +2 ;

				double Raster_ver, Raster_hor, summe;

				double [,] Blurdiag;

				// Zuerst kleine Seitenlänge für erste Seite berechnen
				summe = (Convert.ToDouble(Auswertegebiete) * matrixsize[0] / matrixsize[1]);
				Auswertegebiete_ver = Convert.ToInt16( Math.Round(summe ));
				Raster_ver = Convert.ToDouble(matrixsize[0]) / Convert.ToDouble(Auswertegebiete_ver) ;
				Raster_hor = Convert.ToDouble(matrixsize[1]) / Convert.ToDouble(Auswertegebiete)  ;
				Blurdiag = new double[Auswertegebiete_ver, Auswertegebiete];

				// DEBUG
				//tConsole.Text = Convert.ToString(Auswertegebiete);


				for (i = 0; i <= Auswertegebiete_ver-1; i++)
				{
					for (j = 0; j <= Auswertegebiete -1; j++)
					{
						summe = 0;
						anzahl = 0;

						// Kompensationsvariablen, um nicht Arraygrenzen zu
						// überschreiten
						if (j == Auswertegebiete -1)
							comp = -1;
						else
							comp = 0;
						if (i == Auswertegebiete_ver - 1)
							comp_ver = -1;
						else
							comp_ver = 0;

						for (k = 0 ; k <= Math.Ceiling(Raster_ver-(double)1 + (double)comp_ver); k++)
						{
							for (L = 0 ; L <= Math.Ceiling(Raster_hor- (double)2 + (double)comp); L++)
							{
								if (  Abklinggraph[ ( Convert.ToInt16(Math.Floor( Convert.ToDouble(i)  * Raster_ver)) + k ) , ( Convert.ToInt16(Math.Floor( Convert.ToDouble(j) * Raster_hor)) + L )]  == 0  )
									continue;
								summe = summe + Abklinggraph[ ( Convert.ToInt16(Math.Floor( (i) * Raster_ver)) + k ) , ( Convert.ToInt16(Math.Floor( (j ) * Raster_hor)) + L )];
								anzahl++;

							}
						}
						// Wenn Summe Nicht Null, wert zuweisen, sonst Null zuweisen
						if (summe == 0)
							Blurdiag[i,j] = 0;
						else
							Blurdiag[i,j] = summe / (double)anzahl;
					}
				}
				return Blurdiag;
			}
			else
			{
				
				// Parallel-Code
				//- liefert andere Ergebnisse, warum auch immer
				int Auswertegebiete_ver;

				int[] matrixsize;

				matrixsize = new int[2];
				matrixsize = getmatrixsize(ref Abklinggraph);
				matrixsize[0] = matrixsize[0] + 2;

				matrixsize[1] = matrixsize[1] +2 ;



				double [,] Blurdiag;
				double Raster_ver, Raster_hor, summe;
				// Zuerst kleine Seitenlänge für erste Seite berechnen
				summe = (Convert.ToDouble(Auswertegebiete) * matrixsize[0] / matrixsize[1]);
				Auswertegebiete_ver = Convert.ToInt16( Math.Round(summe ));
				Raster_ver = Convert.ToDouble(matrixsize[0]) / Convert.ToDouble(Auswertegebiete_ver) ;
				Raster_hor = Convert.ToDouble(matrixsize[1]) / Convert.ToDouble(Auswertegebiete)  ;
				Blurdiag = new double[Auswertegebiete_ver, Auswertegebiete];


				Action<int> forloop = i =>
				{

					double summe2 = 0;
					int anzahl2 = 0;
					int comp = 0;
					int comp_ver = 0;
					for (int j = 0; j <= Auswertegebiete -1; j++)
					{

						summe2 = 0;
						anzahl2 = 0;

						// Kompensationsvariablen, um nicht Arraygrenzen zu
						// überschreiten
						if (j == Auswertegebiete -1)
							comp = -1;
						else
							comp = 0;
						if (i == Auswertegebiete_ver - 1)
							comp_ver = -1;
						else
							comp_ver = 0;

						for (int k = 0 ; k <= Math.Ceiling(Raster_ver-(double)1 + (double)comp_ver); k++)
						{
							for (int L = 0 ; L <= Math.Ceiling(Raster_hor- (double)2 + (double)comp); L++)
							{
								if (  Abklinggraph[ ( Convert.ToInt16(Math.Floor( Convert.ToDouble(i)  * Raster_ver)) + k ) , ( Convert.ToInt16(Math.Floor( Convert.ToDouble(j) * Raster_hor)) + L )]  == 0  )
									continue;
								summe2 = summe2 + Abklinggraph[ ( Convert.ToInt16(Math.Floor( (i) * Raster_ver)) + k ) , ( Convert.ToInt16(Math.Floor( (j ) * Raster_hor)) + L )];
								anzahl2++;

							}
						}
						// Wenn Summe Nicht Null, wert zuweisen, sonst Null zuweisen
						if (summe2 == 0)
							Blurdiag[i,j] = 0;
						else
							Blurdiag[i,j] = summe2 / (double)anzahl2;
					}
				};
				Parallel.For(0, Auswertegebiete_ver,forloop);


				return Blurdiag;
			}
			
			

		}
		
		private double [,] ErzeugeAbklinggraph (int[,,] EVektor, int[,] Bild, int Testlinienlaenge, bool DoItSequential)
		{
			if (true == DoItSequential)
			{
				
				// Sequentielle Realisation
				int i,j,k;
				int[] matrixsize;

				matrixsize = new int[2];
				matrixsize = getmatrixsize(ref Bild);

				double[] abtastrichtung;
				double[] pixelreihe;
				double[,] pixelkoord, pixelmatrix;
				double[,] Abklinggraph;

				// Temporäre Variablen
				//double[] Printvekor;

				abtastrichtung = new double[2];
				pixelreihe = new double[2*Testlinienlaenge+1];
				pixelkoord = new double[2*Testlinienlaenge+1,2];
				Abklinggraph = new double[matrixsize[0], matrixsize[1]];

				// SEQUENTIELLE Realisation
				for (i = 0; i < matrixsize[0]; i++)
				{
					for (j = 0; j < matrixsize[1]; j++)
					{
						// Wenn EVektor dort Null, nächster Pixel
						if (EVektor[i,j,2] == 0)
							continue;



						// Berechnung der Abtastrichtung gemäß dem EVektor des Pixels als Einheitsvektor
						abtastrichtung[0] = EVektor[i,j,1] / (Math.Sqrt(EVektor[i,j,0] * EVektor[i,j,0]) + Math.Sqrt(EVektor[i,j,1] * EVektor[i,j,1]));
						abtastrichtung[1] = EVektor[i,j,0] / (Math.Sqrt(EVektor[i,j,0] * EVektor[i,j,0]) + Math.Sqrt(EVektor[i,j,1] * EVektor[i,j,1]));

						// Berechnung der Pixelkoordinaten auf der Testlinienlaenge
						for (k = 0; k <= 2*Testlinienlaenge; k++)
						{//
							pixelkoord[k,0] = ( i + abtastrichtung[0] * (k - Testlinienlaenge));
							pixelkoord[k,1] = ( j + abtastrichtung[1] * (k - Testlinienlaenge));
						}

						// Abbruch, wenn die Vektorenden außerhalb des Bildes liegen
						if ( pixelkoord[0,0] <= 0 || pixelkoord[0,1] <= 0 ||pixelkoord[0,0] >= matrixsize[0] || pixelkoord[0,1] >= matrixsize[1] || pixelkoord[2*Testlinienlaenge,0] <= 0 || pixelkoord[2*Testlinienlaenge,1] <= 0 || pixelkoord[2*Testlinienlaenge,0] >= matrixsize[0] || pixelkoord[2*Testlinienlaenge,1] >= matrixsize[1] )
							continue;

						// Für alle Pixelkoordinaten die Interpolierten Helligkeiten berechnen
						// und in pixelreihe eintragen
						for ( k = 0 ; k <= 2*Testlinienlaenge ; k++)
						{
							pixelmatrix = Interpolationswichtung(ref k, ref pixelkoord);
							pixelreihe[k] = Bild[Convert.ToInt16(pixelmatrix[0,0]), Convert.ToInt16(pixelmatrix[0,1])]  * pixelmatrix[0,2]    +    Bild[Convert.ToInt16(pixelmatrix[1,0]), Convert.ToInt16(pixelmatrix[1,1])]  * pixelmatrix[1,2]    +    Bild[Convert.ToInt16(pixelmatrix[2,0]), Convert.ToInt16(pixelmatrix[2,1])]  * pixelmatrix[2,2]    +    Bild[Convert.ToInt16(pixelmatrix[3,0]), Convert.ToInt16(pixelmatrix[3,1])]  * pixelmatrix[3,2]    ;
						}

						// Elimination von Pseudo-Linien (z.B. Spalt zwischen zwei Blättern)
						if ( pixelreihe[0] > 0.8 * pixelreihe[pixelreihe.Length-1])
							continue;




						Abklinggraph[i,j] = Pixellinie_falten(ref pixelreihe);

					}
				}
				return Abklinggraph;
			}
			
			
			
			else
			{
				
				// Parallele Realisation
				
				int[] matrixsize;
				
				matrixsize = new int[2];
				matrixsize = getmatrixsize(ref Bild);
				// Variable für Zieldaten
				double[,] Abklinggraph;
				Abklinggraph = new double[matrixsize[0], matrixsize[1]];
				
				
				Action<int> ForLoop = i =>
				{
					int j,k;
					double[] abtastrichtung;
					double[] pixelreihe;
					double[,] pixelkoord, pixelmatrix;
					

					abtastrichtung = new double[2];
					pixelreihe = new double[2*Testlinienlaenge+1];
					pixelkoord = new double[2*Testlinienlaenge+1,2];
					
					
					
					for (j = 0; j < matrixsize[1]; j++)
					{
						// Wenn EVektor dort Null, nächster Pixel
						if (EVektor[i,j,2] == 0)
							continue;
						

						
						// Berechnung der Abtastrichtung gemäß dem EVektor des Pixels als Einheitsvektor
						abtastrichtung[0] = EVektor[i,j,1] / (Math.Sqrt(EVektor[i,j,0] * EVektor[i,j,0]) + Math.Sqrt(EVektor[i,j,1] * EVektor[i,j,1]));
						abtastrichtung[1] = EVektor[i,j,0] / (Math.Sqrt(EVektor[i,j,0] * EVektor[i,j,0]) + Math.Sqrt(EVektor[i,j,1] * EVektor[i,j,1]));
						
						// Berechnung der Pixelkoordinaten auf der Testlinienlaenge
						for (k = 0; k <= 2*Testlinienlaenge; k++)
						{//
							pixelkoord[k,0] = ( i + abtastrichtung[0] * (k - Testlinienlaenge));
							pixelkoord[k,1] = ( j + abtastrichtung[1] * (k - Testlinienlaenge));
						}
						
						// Abbruch, wenn die Vektorenden außerhalb des Bildes liegen
						if ( pixelkoord[0,0] <= 0 || pixelkoord[0,1] <= 0 ||pixelkoord[0,0] >= matrixsize[0] || pixelkoord[0,1] >= matrixsize[1] || pixelkoord[2*Testlinienlaenge,0] <= 0 || pixelkoord[2*Testlinienlaenge,1] <= 0 || pixelkoord[2*Testlinienlaenge,0] >= matrixsize[0] || pixelkoord[2*Testlinienlaenge,1] >= matrixsize[1] )
							continue;
						
						// Für alle Pixelkoordinaten die Interpolierten Helligkeiten berechnen
						// und in pixelreihe eintragen
						for ( k = 0 ; k <= 2*Testlinienlaenge ; k++)
						{
							pixelmatrix = Interpolationswichtung(ref k, ref pixelkoord);
							pixelreihe[k] = Bild[Convert.ToInt16(pixelmatrix[0,0]), Convert.ToInt16(pixelmatrix[0,1])]  * pixelmatrix[0,2]    +    Bild[Convert.ToInt16(pixelmatrix[1,0]), Convert.ToInt16(pixelmatrix[1,1])]  * pixelmatrix[1,2]    +    Bild[Convert.ToInt16(pixelmatrix[2,0]), Convert.ToInt16(pixelmatrix[2,1])]  * pixelmatrix[2,2]    +    Bild[Convert.ToInt16(pixelmatrix[3,0]), Convert.ToInt16(pixelmatrix[3,1])]  * pixelmatrix[3,2]    ;
						}
						
						// Elimination von Pseudo-Linien (z.B. Spalt zwischen zwei Blättern)
						if ( pixelreihe[0] > 0.8 * pixelreihe[pixelreihe.Length-1])
							continue;
						
						
						
						
						Abklinggraph[i,j] = Pixellinie_falten(ref pixelreihe);
						
					}
				};
				Parallel.For(0 , matrixsize[0], ForLoop);
				
				
				
				return Abklinggraph;
			}
			
		}
		
		private double Pixellinie_falten (ref double[] Pixelreihe)
		{
			int i, akf_laenge;
			int maxpos;
			int linksschritt, rechtsschritt;
			
			rechtsschritt = 0;
			linksschritt  = 0;
			
			double startschnitt, endschnitt;
			double linkekante, rechtekante;
			double max;
			double[] dx;
			double[] akf;
			
			dx = new double[Pixelreihe.Length - 1];
			max = 0d;
			linkekante = 0d;
			rechtekante = 0d;
			
			startschnitt = 0d;
			endschnitt = 0d;
			
			// Vektor soll von hell nach dunkel zeigen,
			// dehalb Berechnung der Mittelwertes am Anfang und am Ende
			for (i = 0 ; i<= 2; i++)
				startschnitt = startschnitt + Pixelreihe [i];
			
			for (i = Pixelreihe.Length-1 ; i>= Pixelreihe.Length-3; i--)
				endschnitt = endschnitt + Pixelreihe [i];
			// Wenn von dunkel nach Hell, reihenfolge umdrehen
			if (startschnitt < endschnitt)
			{
				double[] temparray;
				temparray = new double[Pixelreihe.Length];
				for (i = 0; i <= Pixelreihe.Length-1; i++)
					temparray[Pixelreihe.Length -1 - i] = Pixelreihe[i];
				for (i = 0; i <= Pixelreihe.Length-1; i++)
					Pixelreihe[i] = temparray[i];
			}
			
			// Nun E Pixelreihe von Hell nach Dunkel

			

			
			// Bildung der Ableitung
			for (i = 0; i <= Pixelreihe.Length-2; i++)
			{
				dx[i] = - Pixelreihe[i+1] + Pixelreihe[i];
			}
			
			// Durchführung der Autokorrelation
			akf = Autokorrelation(ref dx);
			akf_laenge = akf.Length-1;
			
			// Suchen des Maximums im Array - springt auf linke Maximum
			maxpos = 0;
			for (i = 0; i <= akf_laenge; i++)
			{
				if (akf[i] > max)
				{
					max = akf[i];
					maxpos = i;
				}
			}
			
			// Wenn Maximum am Rand liegt, Abbruch und Zurückgabe von Null
			if ( (maxpos < 3) || (maxpos > akf_laenge - 3) )
				return 0d;
			
			// Interpolation des realen Maximums via Quadratische Polynom-Bildung
			// um das Maximum und Punkte links & rechts davon
			max = akf[maxpos] - (akf[maxpos-1] - akf[maxpos+1] ) * (akf[maxpos-1] - akf[maxpos+1] ) / 8 / (akf[maxpos-1] - 2* akf[maxpos] + akf[maxpos]) ;

			// 
			// Prüfen ob interpoliertes Maximum links oder rechts von maxpos liegt
			if (akf[maxpos-1] <= akf[maxpos] )
			{
				linksschritt = 1;
			}
			else
			{
				rechtsschritt = 1;
			}
			
			// Prüfkriterium (Keine Ahnung wofür das mal war)
			if ( 0 >= (maxpos -1 - linksschritt))
				return 0d;
			
			// Linke Kante suchen
			{
				for (i = 0; i<= maxpos - 1 - linksschritt; i++)
				{
					// Suche von Maimum aus , ob Wert unter 20% des Maximums abgesunken
					if (akf[maxpos - i] < 0.2 * max)
					{
						linkekante = (maxpos - i) + (0.2* max - akf [maxpos - i] ) / (     Math.Abs( 0.2 * max - akf[maxpos - i] ) + Math.Abs (0.2 * max - akf[maxpos - i +1])     ) ;
						break;
						//linke_Kante = (b-h) + ( 0.2 * a - akf_dx(b-h)) / ( abs( 0.2 * a - akf_dx(b-h) ) + abs( 0.2 * a - akf_dx(b-h+1) )    );
					}
					
				}
				
				// Wenn keine Kante gefunden wurde
				if ( i ==(maxpos-1-linksschritt) )
					return 0d;
			}
			
			// Rechte Kante suchen
			{
				for (i = (maxpos + rechtsschritt) ; i < akf_laenge - rechtsschritt; i++)
				{
					if (akf[i] < 0.2 * max)
					{
						//i--;
						rechtekante = i - (0.2 * max - akf[i]) / ( Math.Abs ( 0.2 * max - akf[i] ) + Math.Abs(0.2 * max - akf[i+1]));
						break;
					}
				}
				
				// Wenn keine Kante gefunden, Abbruch
				if ( i == akf_laenge -1 - rechtsschritt)
					return 0d;
			}
			
			// Abstand zwischen den Zwei Interpolierten 20% Abkling-Kanten wird zurück gegeben
			return rechtekante - linkekante;

		}
		
		private double[] Autokorrelation (ref double[] Vektor)
		{ // Vektoren müssen die gleiche Länge haben
			int i,j, Laenge;
			double[] Faltung;
			
			Laenge = Vektor.Length;
			Faltung = new double[2 * Laenge - 1];
			
			// für die Erste Hälfte des Vektors plus die Mitte
			for (i = 0; i<= Laenge -1; i++)
			{
				// Anzahl der Multiplikationen
				for (j = 0; j <= i ; j++)
					Faltung[i] = Faltung[i] + Vektor[j] * Vektor[i-j];
			}
			// die zweite Hälfte
			for (i = 2 ; i <= Laenge ; i++)
			{
				// Anzahl der Multiplikationen
				for (j = 0; j<= Laenge  -i; j++)
					Faltung[Laenge  + i -2 ] = Faltung[ Laenge + i -2] + Vektor[j+1 +i -2]* Vektor[Laenge-j-1] ;
			}
			
			return Faltung;
		}
		
		
		
		private byte[] BildToByteArray(ref Image Bild, System.Drawing.Imaging.ImageFormat Bildformat)
		{
			System.IO.MemoryStream IS = new System.IO.MemoryStream(0);
			Bild.Save(IS, Bildformat);
			//Bild.Save("C:/test.bmp",System.Drawing.Imaging.ImageFormat.Bmp);
			IS.Flush();
			return IS.ToArray();
		}
		
		
//		private int[,] ausbitmap(Bitmap testbild)
//		{
//
//
//			// Sequentiell
		////
		////			int hoehe, breite;
		////			int j = 0, k = 0;
		////			int[,] Bild;
		////			Color RGB;
		////			hoehe = testbild.Height;
		////			breite = testbild.Width;
		////			Bild = new int[hoehe,breite];
		////
		////			// Bild aus Bitmap in Integer-Array überführen
		////			for (j=0; j < hoehe; j++)
		////			{
		////				for (k = 0; k < breite; k ++)
		////				{
		////					// Übertragung des Rot-Anteils des Pixels in eine Colorvariable
		////					RGB = testbild.GetPixel(k,j);
		////					// Anschließend Konvertierung in ein Int16
		////					Bild[j,k] = Convert.ToInt16(RGB.R.ToString());
		////				}
		////
		////			}
//
//			// Parallel
//
//			int hoehe, breite;
//			//int j = 0, k = 0;
//			int[,] Bild;
//			Color RGB;
//			hoehe = testbild.Height;
//			breite = testbild.Width;
//			Bild = new int[hoehe,breite];
//
//			// Bild aus Bitmap in Integer-Array überführen
//			//for (j=0; j < hoehe; j++)
//			Action<int> forloop = j =>
//			{
//				for (int k = 0; k < breite; k ++)
//				{
//					// Übertragung des Rot-Anteils des Pixels in eine Colorvariable
//					RGB = testbild.GetPixel(k,j);
//					// Anschließend Konvertierung in ein Int16
//					Bild[j,k] = Convert.ToInt16(RGB.R.ToString());
//				}
//
//			};
//			Parallel.For(0,hoehe, forloop);
//
//			// Horizontal Differenzieren
//
//
//
//			return Bild;
//		}
		
		private int[,,] EHV_Sort1( int[,,] EVektor, int[,] betragskarte, int EHV_SortKonstante, int minKantenkontrast, bool DoItSequential)
		{
			if (true == DoItSequential)
			{
				int i,j,k,m;
				//int j,k,m;
				Boolean ExisMax;
				int[] matrixsize;
				matrixsize = new int[2];
				matrixsize = getmatrixsize(ref betragskarte);
				
				// Sequentieller Code:
				for (i = + EHV_SortKonstante; i <= matrixsize[0]-1-EHV_SortKonstante; i++)
				{
					for (j = + EHV_SortKonstante; j <= matrixsize[1]-1-EHV_SortKonstante; j++)
					{
						ExisMax = false;
						// Betrachtung der Beträge, nicht der EVektoren
						// um Kante nicht zu verbreitern
						//RefSize = Convert.ToInt16(Math.Sqrt((EVektor[i,j,0])*(EVektor[i,j,0]) + (EVektor[i,j,1])*(EVektor[i,j,1])));
						;
						// Wenn kleiner als Kontrastvorgabge -> ausmappen
						if (betragskarte[i,j] < minKantenkontrast)
						{
							continue;
						}
						// Wenn beide EVektoren Null sind -> ausmappen
						if ( (EVektor[i,j,0] == 0) && (EVektor[i,j,1] == 0) )
							continue;

						//					if (( i == 4 ) && ( j == 2569))
						//					{
						//						i++ ;
						//						i--;
						//					}

						// Innere Schleife, welche die Umgebung des aktuellen
						// Pixels abrastert
						for (k = -EHV_SortKonstante ; k <= EHV_SortKonstante; k++)
						{
							for (m = -EHV_SortKonstante ; m <= EHV_SortKonstante; m++)
							{
								if (betragskarte[i,j] < betragskarte[i+k,j+m])
									//(RefSize < Math.Sqrt((EVektor[i+k,j+m,0])*(EVektor[i+k,j+m,0]) + (EVektor[i+k,j+m,1])*(EVektor[i+k,j+m,1])) )
								{
									ExisMax = true;
									break;
								}
							}
							if (ExisMax == true) break;
						}
						if (ExisMax == false)
							EVektor[i,j,2] = 1;
					}
				}
				
				
				return EVektor;
			}
			
			
			else
			{
				
				int[] matrixsize;
				matrixsize = new int[2];
				matrixsize = getmatrixsize(ref betragskarte);
				
				
				// Paralleler Code:
				//for (i = + EHV_SortKonstante; i <= matrixsize[0]-1-EHV_SortKonstante; i++)
				Action<int> forLoop2 = i =>
				{
					Boolean ExisMax;
					int j,k,m;
					for (j = + EHV_SortKonstante; j <= matrixsize[1]-1-EHV_SortKonstante; j++)
					{
						ExisMax = false;
						// Betrachtung der Beträge, nicht der EVektoren
						// um Kante nicht zu verbreitern
						//RefSize = Convert.ToInt16(Math.Sqrt((EVektor[i,j,0])*(EVektor[i,j,0]) + (EVektor[i,j,1])*(EVektor[i,j,1])));
						;
						// Wenn kleiner als Kontrastvorgabge -> ausmappen
						if (betragskarte[i,j] < minKantenkontrast)
						{
							continue;
						}
						// Wenn beide EVektoren Null sind -> ausmappen
						if ( (EVektor[i,j,0] == 0) && (EVektor[i,j,1] == 0) )
							continue;
						

						// Innere Schleife, welche die Umgebung des aktuellen
						// Pixels abrastert
						for (k = -EHV_SortKonstante ; k <= EHV_SortKonstante; k++)
						{
							for (m = -EHV_SortKonstante ; m <= EHV_SortKonstante; m++)
							{
								if (betragskarte[i,j] < betragskarte[i+k,j+m])
									//(RefSize < Math.Sqrt((EVektor[i+k,j+m,0])*(EVektor[i+k,j+m,0]) + (EVektor[i+k,j+m,1])*(EVektor[i+k,j+m,1])) )
								{
									ExisMax = true;
									break;
								}
							}
							if (ExisMax == true) break;
						}
						if (ExisMax == false)
							EVektor[i,j,2] = 1;
					}
				};
				Parallel.For( EHV_SortKonstante, matrixsize[0]-EHV_SortKonstante, forLoop2);
				
				return EVektor;
			}
		}
		
		private int[,,] EHV_Sort2 (int[,,] EVektor, int Quadratausdehnung, int Uniformitaetsbereich, double Uniformitaetsguete, bool DoItSequential)
		{
			
			
			if (true == DoItSequential)
			{
				// Sequentielle Realisierung
				bool phasendivergenz;
				int i,j,k;
				int[] matrixsize;
				double lokalephase;
				double[] abtastrichtung;
				double[] phasenreihe;
				phasenreihe = new double[2*Uniformitaetsbereich+1];

				matrixsize = new int[2];
				double[,] pixelkoord, pixelmatrix;
				pixelkoord = new double[2*Uniformitaetsbereich+1,4];
				abtastrichtung = new double[2];


				matrixsize = getmatrixsize(ref EVektor);
				// fuer alle Pixel
				

				for (i = Quadratausdehnung; i <= matrixsize[0] - Quadratausdehnung; i++)
				{
					for (j = Quadratausdehnung; j <= matrixsize[1] - Quadratausdehnung; j++)
					{
						// Wenn Pixel ausgemappt, springe zum nächsten
						if (0 == EVektor[i,j,2])
							continue;

						// Ansonsten weitermachen

						// Phase des Einheitsvektors berechnen, 90° dazu addieren,
						// und als Abtastrichtung speichern
						abtastrichtung[0] = Math.Cos( Math.Atan2( EVektor[i,j,1], EVektor[i,j,0] ) + Math.PI / 2);
						abtastrichtung[1] = Math.Sin( Math.Atan2( EVektor[i,j,1], EVektor[i,j,0] ) + Math.PI / 2);

						for (k=0 ; k<= 2*Uniformitaetsbereich; k++)
						{
							pixelkoord[k,0] = i + abtastrichtung[1]*(k-Uniformitaetsbereich);
							pixelkoord[k,1] = j + abtastrichtung[0]*(k-Uniformitaetsbereich);
						}


						{// Wenn die Enden des Vektors außerhalb der Matrix liegen, Abbruch
							if ( (pixelkoord[0,0] <= 1) || (pixelkoord[0,1] <= 1 ) || (pixelkoord[0,0] >= matrixsize[0]) || (pixelkoord[0,1] >= matrixsize[1])  )
							{
								continue;
							}
							if ( (pixelkoord[2*Uniformitaetsbereich,0] <= 1) || (pixelkoord[2*Uniformitaetsbereich,1] <= 1 ) || (pixelkoord[2*Uniformitaetsbereich,0] >= matrixsize[0]) || ( pixelkoord[2*Uniformitaetsbereich,1] >= matrixsize[1])  )
							{
								continue;
							}
						}


						// Falls Vektor im Bild liegt, gehts weiter
						for (k=0; k<= 2*Uniformitaetsbereich;k++)
						{
							// Berechnung der vier umgebenden Pixelkoordinaten und
							// ihrer Wichtung
							pixelmatrix = Interpolationswichtung(ref k, ref pixelkoord);

							// Anwendung der Wichtung auf Einheitsvektor
							// Speicherung der Summation in pixelkoord[k,2:3]
							pixelkoord[k,2] = EVektor[Convert.ToInt16(pixelmatrix[0,0]), Convert.ToInt16(pixelmatrix[0,1]),0]  * pixelmatrix[0,2]    +    EVektor[Convert.ToInt16(pixelmatrix[1,0]), Convert.ToInt16(pixelmatrix[1,1]),0]  * pixelmatrix[1,2]    +    EVektor[Convert.ToInt16(pixelmatrix[2,0]), Convert.ToInt16(pixelmatrix[2,1]),0]  * pixelmatrix[2,2]    +    EVektor[Convert.ToInt16(pixelmatrix[3,0]), Convert.ToInt16(pixelmatrix[3,1]),0]  * pixelmatrix[3,2]    ;
							pixelkoord[k,3] = EVektor[Convert.ToInt16(pixelmatrix[0,0]), Convert.ToInt16(pixelmatrix[0,1]),1]  * pixelmatrix[0,2]    +    EVektor[Convert.ToInt16(pixelmatrix[1,0]), Convert.ToInt16(pixelmatrix[1,1]),1]  * pixelmatrix[1,2]    +    EVektor[Convert.ToInt16(pixelmatrix[2,0]), Convert.ToInt16(pixelmatrix[2,1]),1]  * pixelmatrix[2,2]    +    EVektor[Convert.ToInt16(pixelmatrix[3,0]), Convert.ToInt16(pixelmatrix[3,1]),1]  * pixelmatrix[3,2]    ;
							//aus MATLAB: pixelkoord(k,3:4) =    Einheitsvektor(pixelmatrix(1,1), pixelmatrix(1,2),1:2) .* pixelmatrix(1,3)   + Einheitsvektor(pixelmatrix(2,1), pixelmatrix(2,2),1:2) .* pixelmatrix(2,3)     + Einheitsvektor(pixelmatrix(3,1), pixelmatrix(3,2),1:2) .* pixelmatrix(3,3)   + Einheitsvektor(pixelmatrix(4,1), pixelmatrix(4,2),1:2) .* pixelmatrix(4,3);
						}


						// Lokale Phase berechnen

						lokalephase = Math.Atan2(EVektor[i,j,1],EVektor[i,j,0]);


						// Phase der Nachbarpunkte berechnen
						for (k = 0 ; k <= 2*Uniformitaetsbereich ; k++)
						{
							phasenreihe[k] = Math.Atan2(pixelkoord[k,3], pixelkoord[k,2]);
							// Matlab: phasen_reihe = atan2(pixelkoord(1:2*Uniformitaetsbereich+1,4),pixelkoord(1:2*Uniformitaetsbereich+1,3));
						}

						// Phasenkorrektur Korrektur-Algorithmus
						// Muss nur arbeiten, wenn lokalephase nahe pi - Uniformitaetsguete
						// oder nahe -p + Uniformitaetsguete

						// erst lokalephase   ist nahe an -pi
						if (lokalephase < - Math.PI + Uniformitaetsguete + 0.05)
						{
							// Alle Werte in phasenreihe welche größer Null sind,
							// um 2* pi   reduzieren
							for (k=0 ; k <= 2*Uniformitaetsbereich; k++)
							{
								if (phasenreihe[k] > 0)
									phasenreihe[k] = phasenreihe[k] - 2*Math.PI;
							}
						}

						// das gleiche nochmal für lokalephase  nahe an +pi
						if (lokalephase > + Math.PI - Uniformitaetsguete - 0.05)
						{
							// Alle Werte in phasenreihe welche kleiner Null sind,
							// um 2* pi  erhöhen
							for (k=0 ; k <= 2*Uniformitaetsbereich; k++)
							{
								if (phasenreihe[k] < 0)
									phasenreihe[k] = phasenreihe[k] + 2*Math.PI;
							}
						}

						// Prüfen, ob die (lokalephase - phasenreihe) nicht Uniformität
						// überschreitet
						phasendivergenz = false;
						for (k=0; k <= 2*Uniformitaetsbereich;k++)
						{
							if ( Math.Abs(lokalephase - phasenreihe[k]) < Uniformitaetsguete)
								continue;
							else
								phasendivergenz = true;

							if (phasendivergenz)
								break;
						}
						if (phasendivergenz)
							EVektor[i,j,2] = 0;
					}
				}
				
				return EVektor;
			}
			
			
			else
			{
				
				
				
				// Parallele Realisation
				
				int[] matrixsize;
				


				matrixsize = new int[2];
				matrixsize = getmatrixsize(ref EVektor);
				Action<int> forLoop = i =>
				{
					
					// Variable in Schleife deklarieren
					double lokalephase;
					bool phasendivergenz;
					int j,k;
					double[] abtastrichtung;
					double[] phasenreihe;
					phasenreihe = new double[2*Uniformitaetsbereich+1];
					double[,] pixelkoord, pixelmatrix;
					pixelkoord = new double[2*Uniformitaetsbereich+1,4];
					abtastrichtung = new double[2];
					
					
					for (j = Quadratausdehnung; j <= matrixsize[1] - Quadratausdehnung; j++)
					{
						// Wenn Pixel ausgemappt, springe zum nächsten
						if (0 == EVektor[i,j,2])
							continue;
						
						// Ansonsten weitermachen
						
						// Phase des Einheitsvektors berechnen, 90° dazu addieren,
						// und als Abtastrichtung speichern
						abtastrichtung[0] = Math.Cos( Math.Atan2( EVektor[i,j,1], EVektor[i,j,0] ) + Math.PI / 2);
						abtastrichtung[1] = Math.Sin( Math.Atan2( EVektor[i,j,1], EVektor[i,j,0] ) + Math.PI / 2);
						
						for (k=0 ; k<= 2*Uniformitaetsbereich; k++)
						{
							pixelkoord[k,0] = i + abtastrichtung[1]*(k-Uniformitaetsbereich);
							pixelkoord[k,1] = j + abtastrichtung[0]*(k-Uniformitaetsbereich);
						}
						
						
						{// Wenn die Enden des Vektors außerhalb der Matrix liegen, Abbruch
							if ( (pixelkoord[0,0] <= 1) || (pixelkoord[0,1] <= 1 ) || (pixelkoord[0,0] >= matrixsize[0]) || (pixelkoord[0,1] >= matrixsize[1])  )
							{
								continue;
							}
							if ( (pixelkoord[2*Uniformitaetsbereich,0] <= 1) || (pixelkoord[2*Uniformitaetsbereich,1] <= 1 ) || (pixelkoord[2*Uniformitaetsbereich,0] >= matrixsize[0]) || ( pixelkoord[2*Uniformitaetsbereich,1] >= matrixsize[1])  )
							{
								continue;
							}
						}
						
						
						// Falls Vektor im Bild liegt, gehts weiter
						for (k=0; k<= 2*Uniformitaetsbereich;k++)
						{
							// Berechnung der vier umgebenden Pixelkoordinaten und
							// ihrer Wichtung
							pixelmatrix = Interpolationswichtung(ref k, ref pixelkoord);
							
							// Anwendung der Wichtung auf Einheitsvektor
							// Speicherung der Summation in pixelkoord[k,2:3]
							pixelkoord[k,2] = EVektor[Convert.ToInt16(pixelmatrix[0,0]), Convert.ToInt16(pixelmatrix[0,1]),0]  * pixelmatrix[0,2]    +    EVektor[Convert.ToInt16(pixelmatrix[1,0]), Convert.ToInt16(pixelmatrix[1,1]),0]  * pixelmatrix[1,2]    +    EVektor[Convert.ToInt16(pixelmatrix[2,0]), Convert.ToInt16(pixelmatrix[2,1]),0]  * pixelmatrix[2,2]    +    EVektor[Convert.ToInt16(pixelmatrix[3,0]), Convert.ToInt16(pixelmatrix[3,1]),0]  * pixelmatrix[3,2]    ;
							pixelkoord[k,3] = EVektor[Convert.ToInt16(pixelmatrix[0,0]), Convert.ToInt16(pixelmatrix[0,1]),1]  * pixelmatrix[0,2]    +    EVektor[Convert.ToInt16(pixelmatrix[1,0]), Convert.ToInt16(pixelmatrix[1,1]),1]  * pixelmatrix[1,2]    +    EVektor[Convert.ToInt16(pixelmatrix[2,0]), Convert.ToInt16(pixelmatrix[2,1]),1]  * pixelmatrix[2,2]    +    EVektor[Convert.ToInt16(pixelmatrix[3,0]), Convert.ToInt16(pixelmatrix[3,1]),1]  * pixelmatrix[3,2]    ;
							//aus MATLAB: pixelkoord(k,3:4) =    Einheitsvektor(pixelmatrix(1,1), pixelmatrix(1,2),1:2) .* pixelmatrix(1,3)   + Einheitsvektor(pixelmatrix(2,1), pixelmatrix(2,2),1:2) .* pixelmatrix(2,3)     + Einheitsvektor(pixelmatrix(3,1), pixelmatrix(3,2),1:2) .* pixelmatrix(3,3)   + Einheitsvektor(pixelmatrix(4,1), pixelmatrix(4,2),1:2) .* pixelmatrix(4,3);
						}
						
						
						// Lokale Phase berechnen
						
						lokalephase = Math.Atan2(EVektor[i,j,1],EVektor[i,j,0]);
						
						
						// Phase der Nachbarpunkte berechnen
						for (k = 0 ; k <= 2*Uniformitaetsbereich ; k++)
						{
							phasenreihe[k] = Math.Atan2(pixelkoord[k,3], pixelkoord[k,2]);
							// Matlab: phasen_reihe = atan2(pixelkoord(1:2*Uniformitaetsbereich+1,4),pixelkoord(1:2*Uniformitaetsbereich+1,3));
						}
						
						// Phasenkorrektur Korrektur-Algorithmus
						// Muss nur arbeiten, wenn lokalephase nahe pi - Uniformitaetsguete
						// oder nahe -p + Uniformitaetsguete
						
						// erst lokalephase   ist nahe an -pi
						if (lokalephase < - Math.PI + Uniformitaetsguete + 0.05)
						{
							// Alle Werte in phasenreihe welche größer Null sind,
							// um 2* pi   reduzieren
							for (k=0 ; k <= 2*Uniformitaetsbereich; k++)
							{
								if (phasenreihe[k] > 0)
									phasenreihe[k] = phasenreihe[k] - 2*Math.PI;
							}
						}
						
						// das gleiche nochmal für lokalephase  nahe an +pi
						if (lokalephase > + Math.PI - Uniformitaetsguete - 0.05)
						{
							// Alle Werte in phasenreihe welche kleiner Null sind,
							// um 2* pi  erhöhen
							for (k=0 ; k <= 2*Uniformitaetsbereich; k++)
							{
								if (phasenreihe[k] < 0)
									phasenreihe[k] = phasenreihe[k] + 2*Math.PI;
							}
						}
						
						// Prüfen, ob die (lokalephase - phasenreihe) nicht Uniformität
						// überschreitet
						phasendivergenz = false;
						for (k=0; k <= 2*Uniformitaetsbereich;k++)
						{
							if ( Math.Abs(lokalephase - phasenreihe[k]) < Uniformitaetsguete)
								continue;
							else
								phasendivergenz = true;
							
							if (phasendivergenz)
								break;
						}
						if (phasendivergenz)
							EVektor[i,j,2] = 0;
					}
				};
				Parallel.For(Quadratausdehnung, matrixsize[0] - Quadratausdehnung +1 , forLoop);
				//for (i = Quadratausdehnung; i <= matrixsize[0] - Quadratausdehnung; i++)
				
				
				
				return EVektor;
			}
		}
		
//		private int CountNZero(int[,,] Matrix, int Dimension)
//		{
//
		////			// Sequentiell
		////			int NZeros;
		////			int i,j;
		////			int[] matrixsize;
		////
		////			NZeros = 0;
		////			matrixsize = new int[2];
		////			matrixsize = getmatrixsize(ref Matrix);
		////
		////			for (i = 0; i <= matrixsize[0]; i++)
		////			{
		////				for (j = 0; j <= matrixsize[1]; j++)
		////				{
		////					if (Matrix[i,j,Dimension] != 0)
		////						NZeros++;
		////				}
		////			}
		////
//
//
//			// Parallel
//			int NZeros;
//
//			int[] matrixsize;
//
//			NZeros = 0;
//			matrixsize = new int[2];
//			matrixsize = getmatrixsize(ref Matrix);
//			Action<int> forloop = i =>
//			{
//				for (int j = 0; j <= matrixsize[1]; j++)
//				{
//					if (Matrix[i,j,Dimension] != 0)
//						NZeros++;
//				}
//			};
//			Parallel.For(0,matrixsize[0]+1, forloop);
//			//for (i = 0; i <= matrixsize[0]; i++)
//
//			return NZeros;
//		}
		
		
		private double[,] Interpolationswichtung (ref int Zeile, ref double[,] inputkoord)
		{
			int k;
			double wichtungssumme;
			double[,] pixelraster;
			pixelraster = new double[4,3];
			
			{// Prüfen ob ein Betrag genau auf eine glatte Zahl fällt
				// Wenn dass der Fall ist, dann ganz gering auslenken
				// Beeinflusst Ergebnis der Wichtung kaum.
				if ( inputkoord[Zeile,0] == Math.Round(inputkoord[Zeile,0]) )
					inputkoord[Zeile,0] = inputkoord[Zeile,0] + 0.0001d;
				if ( inputkoord[Zeile,1] == Math.Round(inputkoord[Zeile,1]) )
					inputkoord[Zeile,1] = inputkoord[Zeile,1] + 0.0001d;
			}
			
			
			{ //  Heraussuchen der 4 Pixel, für welche Wichtung gerechnet wird
				
				// Pixel 1
				pixelraster[0,0] = Math.Round(inputkoord[Zeile,0]);
				pixelraster[0,1] = Math.Round(inputkoord[Zeile,1]);
				
				// Pixel 2
				pixelraster[1, 0] = Math.Round(inputkoord[Zeile,0]);
				if ( (inputkoord[Zeile,1] - Math.Round(inputkoord[Zeile,1])) <= 0)
					pixelraster[1,1] = Math.Floor(inputkoord[Zeile,1]);
				else
					pixelraster[1,1] = Math.Ceiling(inputkoord[Zeile,1]);
				
				// Pixel 3
				if ( inputkoord[Zeile,0] - Math.Round(inputkoord[Zeile,0]) <= 0 )
					pixelraster[2,0] = Math.Floor(inputkoord[Zeile,0]);
				else
					pixelraster[2,0] = Math.Ceiling(inputkoord[Zeile,0]);
				
				pixelraster[2,1] = Math.Round(inputkoord[Zeile,1]);
				
				// Pixel 4
				if ( inputkoord[Zeile,0] - Math.Round(inputkoord[Zeile,0]) <= 0 )
					pixelraster[3,0] = Math.Floor(inputkoord[Zeile,0]);
				else
					pixelraster[3,0] = Math.Ceiling(inputkoord[Zeile,0]);

				if (inputkoord[Zeile,1] - Math.Round(inputkoord[Zeile,1]) <= 0)
					pixelraster[3,1] = Math.Floor(inputkoord[Zeile,1]);
				else
					pixelraster[3,1] = Math.Ceiling(inputkoord[Zeile,1]);
				
			}
			
			// Berechnung der Wichtung
			for (k = 0 ; k <= 3 ; k++)
			{
				pixelraster[k,2] = ( 1 - Math.Abs(pixelraster[k,0] - inputkoord[Zeile,0])) * ( 1 - Math.Abs(pixelraster[k,1] - inputkoord[Zeile,1]));
			}

			// Wichtung normieren
			wichtungssumme = pixelraster[0,2] + pixelraster[1,2] + pixelraster[2,2] + pixelraster[3,2];
			for (k = 0 ; k <= 3 ; k++)
			{
				pixelraster[k,2] = pixelraster[k,2] / wichtungssumme;
			}
			
			return pixelraster;
			
		}

		
		private int[,,] ErzeugeEVektor( int[,] dver,  int[,] dhor,  int[,] betragskarte, bool DoItSequential)
		{
			if (true == DoItSequential)
			{
				// Sequentiell
				int[,,] EVektor;
				int i,j;
				int[] matrixsize;
				matrixsize = new int[2];

				matrixsize = getmatrixsize(ref betragskarte);

				EVektor = new int[matrixsize[0]+1,matrixsize[1] +1,3];

				for (i=1;i<=matrixsize[0]-1;i++)
				{
					for (j=1;j<=matrixsize[1]-1;j++)
					{
						EVektor[i,j,0] = dhor[i,j-1]+dhor[i,j];
						EVektor[i,j,1] = dver[i-1,j]+dver[i,j];
						EVektor[i,j,2] = 0;
					}
				}
				
				return EVektor;
			}
			else
			{
				// Parallel
				int[,,] EVektor;
				int[] matrixsize;
				matrixsize = new int[2];
				
				matrixsize = getmatrixsize(ref betragskarte);
				
				EVektor = new int[matrixsize[0]+1,matrixsize[1] +1,3];
				
				Action<int> forloop = i =>
				{
					for (int j=1;j<=matrixsize[1]-1;j++)
					{
						EVektor[i,j,0] = dhor[i,j-1]+dhor[i,j];
						EVektor[i,j,1] = dver[i-1,j]+dver[i,j];
						EVektor[i,j,2] = 0;
					}
				};
				Parallel.For(1, matrixsize[0] -1 ,forloop);
				
				//	for (i=1;i<=-1;i++)
				
				return EVektor;
			}
		}
		
		private int[,] ErzeugeBetragskarte( int[,] dver, int[,] dhor, bool doItSequential)
		{
			
			if (doItSequential == true)
			{
				// Sequentiell
				int[,] betragskarte;
				int[] matrixsize;
				int i, j;
				//int j;
				matrixsize = new int[2];
				matrixsize = getmatrixsize(ref dver);

				betragskarte = new int[matrixsize[0]+1 , matrixsize[1]+1];
				matrixsize[1]--;


				for (i=0; i<= matrixsize[0]; i++)
				{
					for (j=0; j <= matrixsize[1]; j++)
					{
						betragskarte[i,j] = (int)Math.Sqrt((dver[i,j])*(dver[i,j])  +  (dhor[i,j])*(dhor[i,j]));
					}
				}
				return betragskarte;
			}
			else
			{
				
				// Parallel
				int[,] betragskarte;
				int[] matrixsize;

				matrixsize = new int[2];
				matrixsize = getmatrixsize(ref dver);
				
				betragskarte = new int[matrixsize[0]+1 , matrixsize[1]+1];
				matrixsize[1]--;
				
				Action<int> forloop = i =>
				{
					for (int j=0; j <= matrixsize[1]; j++)
					{
						betragskarte[i,j] = (int)Math.Sqrt((dver[i,j])*(dver[i,j])  +  (dhor[i,j])*(dhor[i,j]));
					}
				};
				Parallel.For(0,matrixsize[0] +1 , forloop);
				
				
				return betragskarte;
			}
		}
		
		private int[,] diff_hor(int[,] matrix, bool DoItSequential)
		{	// Führt Ableitung entlang der horizontalen Pixelreihen
			// durch
			
			if (true == DoItSequential)
			{
				
				// Sequentiell
				int[,] dhor;
				int[] matrixsize;
				matrixsize = new int[2];
				matrixsize = getmatrixsize(ref matrix);
				dhor = new int[matrixsize[0] +1  ,matrixsize[1]];
				int i, j;

				for (i=0 ; i <= matrixsize[0]; i++)
				{
					for (j = 0; j <= matrixsize[1]-1; j++)
					{
						dhor[i,j] = matrix[i,j+1]-matrix[i,j];
					}
				}
				return dhor;
			}
			
			
			else
			{
				// Parallel
				
				int[,] dhor;
				int[] matrixsize;
				matrixsize = new int[2];
				matrixsize = getmatrixsize(ref matrix);
				dhor = new int[matrixsize[0] +1  ,matrixsize[1]];
				
				Action<int> forloop = i =>
				{
					for (int j = 0; j <= matrixsize[1]-1; j++)
					{
						dhor[i,j] = matrix[i,j+1]-matrix[i,j];
					}
				};
				Parallel.For(0,matrixsize[0] +1, forloop);
				
				
				return dhor;
			}
			
		}
		
		
		private int[,] diff_ver(int[,] matrix, bool DoItSequential)
		{
			// Führt Ableitung entlang der Vertikalen Pixelreihen
			// durch
			if (true == DoItSequential)
			{
				
				// Sequentiell
				int[,] dver;
				int[] matrixsize;
				matrixsize = new int[2];
				matrixsize = getmatrixsize(ref matrix);
				dver = new int[matrixsize[0]  ,matrixsize[1]+1];
				int i, j;

				for (i=0 ; i <= matrixsize[0]-1; i++)
				{
					for (j = 0; j <= matrixsize[1]; j++)
					{
						dver[i,j] = matrix[i+1,j]-matrix[i,j];
					}
				}
				return dver;
			}
			else
			{
				// Parallel
				int[,] dver;
				int[] matrixsize;
				matrixsize = new int[2];
				matrixsize = getmatrixsize(ref matrix);
				dver = new int[matrixsize[0]  ,matrixsize[1]+1];
				
				Action <int> forloop = i =>
				{
					for (int j = 0; j <= matrixsize[1]; j++)
					{
						dver[i,j] = matrix[i+1,j]-matrix[i,j];
					}
				};
				Parallel.For(0, matrixsize[0], forloop);
				
				return dver;
			}
			
		}
		
		private int[] getmatrixsize(ref int[,] matrix)
		{
			int[] rueckgabe;
			rueckgabe = new int[2];
			int temp = 0;
			int i=0;
			// Erste Dimension
			try {
				for (i =0; i < 2e6; i++)
					temp = matrix[i, 0];
				
			} catch (Exception) {
				rueckgabe[0] = i-1;
			}
			// Zweite Dimension
			try {
				for (i =0; i < 2e6; i++)
					temp = matrix[0, i];
			} catch (Exception) {
				rueckgabe[1] = i-1;
			}
			return rueckgabe;
			
		}
		
		private int[] getmatrixsize(ref double[,] matrix)
		{
			int[] rueckgabe;
			rueckgabe = new int[2];
			double temp = 0d;
			int i=0;
			// Erste Dimension
			try {
				for (i =0; i < 2e6; i++)
					temp = matrix[i, 0];
				
			} catch (Exception) {
				rueckgabe[0] = i-1;
			}
			// Zweite Dimension
			try {
				for (i =0; i < 2e6; i++)
					temp = matrix[0, i];
			} catch (Exception) {
				rueckgabe[1] = i-1;
			}
			return rueckgabe;
			
		}
		
		private int[] getmatrixsize(ref int[,,] matrix)
		{
			int[] rueckgabe;
			rueckgabe = new int[2];
			int temp = 0;
			int i=0;
			// Erste Dimension
			try {
				for (i =0; i < 2e6; i++)
					temp = matrix[i, 0 , 0];
				
			} catch (Exception) {
				rueckgabe[0] = i-1;
			}
			// Zweite Dimension
			try {
				for (i =0; i < 2e6; i++)
					temp = matrix[0, i , 0];
			} catch (Exception) {
				rueckgabe[1] = i-1;
			}
			return rueckgabe;
			
		}
		
	}
}
